﻿using GrapeCity.Documents.Word;

GcWordDocument doc = new GcWordDocument();

// create 5x6 table
Table table = doc.Body.Tables.Add(new string[][] {
                new string[] { "DESCRIPTION", "DATE RECEIVED", "RECEIVED FROM", "HOW RECEIVED", "LOCATION" },
                new string[] { "This is the description of the best thing ever put into a table", "1/1/2023", "John Smith", "By Hand", "File" },
                new string[] {"", "", "", "", ""},
                new string[] {"", "", "", "", ""},
                new string[] {"", "", "", "", ""},
                new string[] {"", "", "", "", ""}
                // apply Table Grid style
            }, doc.Styles[BuiltInStyleId.TableGrid]);

// iterate columns
for (int c = 0; c < table.Rows[0].Cells.Count; c++)
{
    // iterate cells in the current column
    for (int r = 0; r < table.Rows.Count; r++)
    {
        // set preferred width for each cell according to its column
        PreferredWidth width = table[r, c].Format.PreferredWidth;
        switch (c)
        {
            case 0:
                // set auto width for the first column cells
                width.Type = PreferredWidthType.Auto;
                width.Value = 0;
                break;
            case 1:
                width.Type = PreferredWidthType.Points;
                width.Value = 54;
                break;
            case 2:
                width.Type = PreferredWidthType.Points;
                width.Value = 64.8f;
                break;
            case 3:
                width.Type = PreferredWidthType.Points;
                width.Value = 57.6f;
                break;
            case 4:
                width.Type = PreferredWidthType.Points;
                width.Value = 55.65f;
                break;
        }
    }
}
doc.Save(@"auto-col.docx");